//===========================================================
// FMXTENDR - A DLL which adds a custom menu to the Windows
// 3.x File Manager.             
//
// Copyright (C) 1995 Jonathan Waldman
// Portions (C) Microsoft                
//                                     
// Written for PC Magazine, June 27, 1995, US Edition
//
// Revision History:
//
// 1.0   Initial Release
//
//===========================================================

#include <windows.h>
#include "wfext.h"
#include <shellapi.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "fmxtendr.h"

HANDLE 		ghDllInst;				// instance handle
HMENU   	ghMenu;					// menu handle
WORD    	gwMenuDelta;			// required by File Manager
const char	gReadManual[] = "Please consult the File Hunter documentation "
								"for more information.";
char	LoopStr[1];


int FAR PASCAL LibMain (HANDLE hLibInst,  WORD wDataSeg,
                       WORD cbHeapSize, LPSTR lpszCmdLine)
{
    ghDllInst = hLibInst;
    return (1);
} // LibMain()

int FAR PASCAL __export WEP (int bSystemExit)
{
    return (1);
} // WEP()


HMENU FAR PASCAL __export FMExtensionProc (HWND hwndFM, WORD wMessage,
	LONG lParam)
{
    LPFMS_LOAD  		lpload;
    char        		szFileName [FILE_NAME_LEN];
    static  			FMS_GETDRIVEINFO    fmsDriveInfo;
	int 				i;  
	char				MenuItemString[FILE_NAME_LEN];
        
    switch (wMessage)
    {

    // File Manager events

        case FMEVENT_INITMENU:
        
            break;

        case FMEVENT_LOAD:
        
          	// generate a global menu handle for the menu resource called 
          	// "PCMagMenu" (see FMXTENDR.RC)
            ghMenu = LoadMenu (ghDllInst, "PCMagMenu");

            // create a 32-bit (long) pointer to a Windows 3.1 File Manager-
            // specific structure called "FMS_LOAD"
            lpload  = (LPFMS_LOAD) lParam;          
            
            // store the size of our structure (this is important because there's
            // a variable-length string within the structure itself -- specifically,
            // the name of the menu...)
            lpload->dwSize = sizeof (FMS_LOAD);
            
            // Here's where we can supply the actual text for the File Manager menu
            // bar item. To keep this process generic, we will access File
            // Manager's WINFILE.INI file.
            
            lstrcpy (lpload->szMenuName, "PCMaga&zine");
            
            // store the handle for the pop-up menu that is to be added to 
            // File Manager's main menu in the lpload structure
            lpload->hMenu = ghMenu;                                                       
            
			// start a loop to examine and set the MenuItem text strings
			// from WINFILE.INI's FMXTENDR section
	
			for (i=1;i<4;i++){			          
				itoa(i,LoopStr,10);            
				lstrcpy(MenuItemString,"MenuItem");
				strcat(MenuItemString,LoopStr);		
			 	if (GetPrivateProfileString("FMXTENDR",MenuItemString,"",szFileName,
	        		FILE_NAME_LEN,"WINFILE.INI")) {
					switch (i){
					case 1:
						if (ModifyMenu(ghMenu, IDM_PCMAGAZINE_RUNCUSTOMAPP1, MF_BYCOMMAND, IDM_PCMAGAZINE_RUNCUSTOMAPP1, szFileName)){
						};        
						break;          
					case 2:
						if (ModifyMenu(ghMenu, IDM_PCMAGAZINE_RUNCUSTOMAPP2, MF_BYCOMMAND, IDM_PCMAGAZINE_RUNCUSTOMAPP2, szFileName)){
						};    
						break;
					case 3:
						if (ModifyMenu(ghMenu, IDM_PCMAGAZINE_RUNCUSTOMAPP3, MF_BYCOMMAND, IDM_PCMAGAZINE_RUNCUSTOMAPP3, szFileName)){
						};    
						break;
					};
				};    			
			};
            
            // File Manager requires that we track our own "Delta" value. This
            // gives us (and File Manager) a way to track the changes which are
            // being made to its menu structure.
            gwMenuDelta = lpload->wMenuDelta;            
        
            // return the global menu handle
            return (ghMenu);
			break;

        case FMEVENT_SELCHANGE:                        
			
            break;

        case FMEVENT_UNLOAD:
            
            break;

        case FMEVENT_USER_REFRESH:

            break;               

		// *** VERY IMPORTANT! ***
		// In order for these custom menu events to fire, your menu's 
		// resource ID's MUST be in the value range between 1 and 99.
                
        case IDM_PCMAGAZINE_RUNFILEHUNT:
                  
        	if (!GetPrivateProfileString("FMXTENDR","FileHunter","",szFileName,
        		FILE_NAME_LEN,"WINFILE.INI")) {
        		
				CustMessage1("FileHunter=");
				
			}			
			else {
				SendMessage (hwndFM, FM_GETDRIVEINFO, 0,
	             (LONG) (LPFMS_GETDRIVEINFO) &fmsDriveInfo);
	
				// Convert OEM characters to Windows characters
	            OemToAnsi (fmsDriveInfo.szPath, fmsDriveInfo.szPath);	            
				LaunchMe(szFileName,fmsDriveInfo.szPath);	        
			}
            break;                    

        case IDM_PCMAGAZINE_RUNCUSTOMAPP1:

        	if (!GetPrivateProfileString("FMXTENDR","App1","",szFileName,
        		FILE_NAME_LEN,"WINFILE.INI")) {
        		
				CustMessage1("\042App1=\042 and \042MenuItem1=\042");
				
			}			
			else LaunchMe(szFileName,NULL);	        
            break;                    
            
        case IDM_PCMAGAZINE_RUNCUSTOMAPP2:
        	if (!GetPrivateProfileString("FMXTENDR","App2","",szFileName,
        		FILE_NAME_LEN,"WINFILE.INI")) {
        		
				CustMessage1("\042App2=\042 and \042MenuItem2=\042");
				
			}			
			else LaunchMe(szFileName,NULL);	        
            break;                    

    	case IDM_PCMAGAZINE_RUNCUSTOMAPP3:
    	
           	if (!GetPrivateProfileString("FMXTENDR","App3","",szFileName,
        		FILE_NAME_LEN,"WINFILE.INI")) {
        		
				CustMessage1("\042App3=\042 and \042MenuItem3=\042");
				
			}			
			else LaunchMe(szFileName,NULL);	        
            break;                    

        default:                  
        
    		break;
    }
    return (NULL);

} // FMExtentensionProc()                     

void CustMessage1(char *Msg_Text)
{   
    char message_str[255];                               
    
	strcpy(message_str, "Could not launch application.\n\nBe sure that you "
		"have ");
	strcat(message_str, Msg_Text);
	strcat(message_str, " statements in your WINFILE.INI file under"
		" the section called \042FMXTENDR\042.\n\n");
	strcat(message_str, gReadManual);
		
    MessageBox (NULL, message_str,
                    "PC Magazine's FMXTENDR.DLL - Error",
                    MB_OK | MB_ICONSTOP);
    return;

}//CustMessage1

void LaunchMe(char *filespec, char *commandlinearg)
{                       
	// create a message string buffer
	char message_str[500];

	if ((ShellExecute(ghDllInst, NULL, filespec, 
		commandlinearg, "C:\\windows", SW_SHOWNORMAL)<33)) {
		
		strcpy(message_str, "There was an error when trying to shell to the "
			"application called:\n\n\042");
		strcat(message_str, filespec);
		strcat(message_str, "\042\n\n");
		strcat(message_str, gReadManual);
		MessageBox (NULL, message_str,
	        "PC Magazine's FMXTENDR.DLL - Error",
	        MB_OK | MB_ICONSTOP);
	}    
    return;                                     
    
}//CustMessage2                  
